/**
 * @author Daniel Infante
 *@version 1.0
 */
 
/**
  * Apply the changes done by the user to the tags
  */
 function wordsfinder( ) {
	
	code  = '<fieldset id="keywordsdiv" class="dbx-box">';
	code += '<h3 class="dbx-handle">' + wf.title + '</h3>';
	code += '<div class="dbx-content">';
	code += '<p id="jaxtags">';
	code += '<span id="textcontainer"><textarea id="tagsta" cols="20" rows="10" wrap="soft"></textarea>';
	code += '<div id="tagsdiv">' + formatToDiv(wf.tags) + '</div><div id="ajax-loader"><img src="../wp-content/plugins/wordsfinder/ajax-loader.gif" /></div></span>';
	code += '<span id="howto">' + wf.howto + '</span>';
	code += '</p>';
	code += '<input id="generateButton" type="button" value="' + wf.generate + '" /><input id="applyButton" type="button" value="' + wf.apply +'" /><input id="editButton" type="button" value="' + wf.edit +'" /></div>';
	code += '</fieldset>';
			
	new Insertion.Top( 'grabit', code );
	init( );

}

/**
  * Initializes the box and its elements
  */
function init( ) {
	[ 'tagdiv', 'tags-input', 'tagsta', 'applyButton', 'ajax-loader' ].each( Element.hide );
	[ 'tagsdiv', 'editButton' ].each( Element.show );
	$( 'generateButton' ).observe( 'click', generate );
	$( 'editButton' ).observe( 'click', edit );
	$( 'applyButton' ).observe( 'click', save );
}

function parse( responseText ) {
	
	if (window.DOMParser) {
		try { 
			dom = (new DOMParser()).parseFromString(responseText, "text/xml"); 
		} 
		catch (e) { dom = null; }
    } else if (window.ActiveXObject) {
		try {
			dom = new ActiveXObject('Microsoft.XMLDOM');
			dom.async = false;
			if (!dom.loadXML(responseText))
				window.alert(dom.parseError.reason + dom.parseError.srcText);
			} 
		catch (e) { dom = null; }
    } else
		alert("cannot parse xml response!");
	
	keywords = dom.getElementsByTagName( 'keyword' );
		
	tags = '';
	
	if( wf.limit != 0 & wf.limit < keywords.length)
		limit = wf.limit;
	else 
		limit = keywords.length;
	
	for( i = 0; i < limit - 1; i++ ) {
		tags += keywords[i].childNodes[0].nodeValue + ', ';
	}
	
	tags += keywords[limit-1].childNodes[0].nodeValue;
	
	$( 'tagsta' ).value = tags;
	
	save();
	
}

/**
  * Calls WordsFinder API to generate keywords
  */
function generate( ) {

	$( 'ajax-loader' ).show();
	
	if( typeof tinyMCE != "undefined" ) {
		var editor = tinyMCE.getInstanceById( 'content' );
	
		postContent = editor.getHTML( ).stripTags( );
	} else
	postContent = $( 'content' ).value;
	
	
	new Ajax.Request( '../wp-content/plugins/wordsfinder/proxy.php', {
		parameters: { text: postContent, type: 'basic', userid: wf.key, url: 'http://www.wordsfinder.com/keyrest.php'  },
		onSuccess: function( transport ) { parse( transport.responseText ); $( 'ajax-loader' ).hide(); }
	});

}
 
/**
  * Switches to edit mode
  */
function edit( ) {
	$( 'tagsta' ).value = formatToEdit( $( 'tagsdiv' ).innerHTML );
	[ 'tagsdiv', 'editButton' ].each( Element.hide );
	[ 'tagsta', 'applyButton' ].each( Element.show );
	$( 'tagsta' ).activate( );
}
  
/**
  * Apply the changes done by the user to the tags
  */
function save() {
	$('tagsdiv').innerHTML = formatToDiv($('tagsta').getValue());
	$('tags-input').value = $('tagsta').getValue();
	['tagsta', 'applyButton'].each(Element.hide);
	['tagsdiv', 'editButton'].each(Element.show);
}

/**
  * Opens the box
  */
function toggle() {

	$('keywordsdiv').className = "dbx-box dbx-box-open dbxid0";
	$('keywordsdiv').getElementsByTagName('A')[0].className = "dbx-toggle dbx-toggle-open";
	
}

/**
  * Adds the clicked tag as a category
  *
  * @param String tag tag clicked by the user
  */
function addAsCategory(tag) {

	$('newcat').value = tag;
	catList.ajaxAdder('category', 'jaxcat');
	
}

/**
  * Prepares the tags string for presentation (Link behaviour)
  *
  * @param String tags string with comma separated tags
  * @return String string containing the HTML to display the tags as links
  */
function formatToDiv(tags) {

	if(!tags.blank()) {
		var tagsTemplate = new Template('<a href="javascript:void(null)" onclick="addAsCategory(\'#{tag}\')">#{tag}</a>');
	
		tagsArray = tags.split(',');
		tagsArray.each(function(s) {s.strip()});
	
		divContent = '';
		tagsArray.each(function(s) { divContent+= tagsTemplate.evaluate({tag: s}) });
	
		divContent = divContent.gsub('><','>, <');
	
		return divContent;
	} else
		return tags;
		
}

/**
  * Prepares the tags string for presentation in edit mode (Strips the HTML tags)
  *
  * @param String tags string containing the tags
  * @retutn String stripped string with the tags separated with commas
  */
function formatToEdit(tags) {

	return tags.stripTags();
	
}

/**
  * Gets the API status from wordsfinder and displays it in the options page
  */
function getApiStatus() {
	
	new Ajax.Updater( 'statusdiv', '../wp-content/plugins/wordsfinder/proxy_services.php', {
		parameters: { userid: key, userurl: user_url, url: 'http://www.wordsfinder.com/getapistatus.php' },
		onSuccess: function( transport ) { $( 'ajax-loader' ).hide(); }
	});
	
}

/**
  * Gets and displays the message from wordsfinder
  */
function getMessage() {
	
	$('wordsfinder-message').hide();
	
	new Ajax.Updater( 'wordsfinder-message', '../wp-content/plugins/wordsfinder/proxy_services.php', {
		parameters: { userid: key, userurl: user_url, url: 'http://www.wordsfinder.com/getmessage.php' },
		onSuccess: function( transport ) { if(transport.responseText != "no-message")	{ $( 'admin-menu' ).setStyle({marginBottom: '5em'}); $( 'wordsfinder-message' ).show(); }}
	});
	
}